import processing.sound.*;

// VARIABLEN FÜR DAS SPIEL
int spielStatus = 0;
String titelName = "JungleRun";
int anzahlBananen;
int zeitSpeicherung;
int hintergrundX, hintergrundY;
int leben;
int lebenVariable = 5;
boolean wennSpielerSpringt;
int x, y;
int spielerAnimationsNummer = 0;
int spielerHWert;
int sprungkraft = 110;
float spielergravitation = 0.8;
float speedSprungkraft;
PImage hintergrund, info;
PImage dschungel;
PImage affe1, affe2;
PImage BananeImage;
PFont dschungelSchriftart;
SoundFile menu, jumpSound, game, BananeS, damageSound;
float abstandPflanzen = 90;
float pflanzenProzent = 70;
float geschwindigkeitPflanzen = 1.0;
ArrayList<Gegner> listevonGegner = new ArrayList<Gegner>();
ArrayList<PImage> gegners = new ArrayList<PImage>();
ArrayList<Banane> Bananes = new ArrayList<Banane>();

void setup() {
  background(255);
  fullScreen();

  // BILDER WERDEN GELADEN
  dschungel = loadImage("./bilder/spiel.jpg");
  dschungelSchriftart = createFont("./schriftarten/JungleTree.ttf", 30);
  hintergrund = loadImage("./bilder/hintergrund.jpg");
  hintergrund.resize(width, height);
  info = loadImage("./bilder/info.png");
  info.resize(width, height);
  affe1 = loadImage("./bilder/affe1.png");
  affe2 = loadImage("./bilder/affe2.png");

  // SOUNDS WERDEN GELADEN
  menu  = new SoundFile(this, "./sounds/menu.wav");
  game = new SoundFile(this, "./sounds/game.wav");
  jumpSound = new SoundFile(this, "./sounds/jump.wav");
  BananeS = new SoundFile(this, "./sounds/Banane.wav");
  damageSound = new SoundFile(this, "./sounds/damage.wav");

  // STARTWERTE WERDEN GESETZT
  spielerHWert = height;
  BananeImage = loadImage("./bilder/Banane.png");
  BananeImage.resize(60, 60);
  zeichneFenster(true);

  // HINDERNISSE BILDER WERDEN GELADEN
  for (int i = 1; i <= 2; i++) {
    PImage gBild = loadImage("./bilder/hindernisse/hinderniss" + i + ".png");
    gBild.resize(int(gBild.width*0.5), int(gBild.height*0.5));
    gegners.add(gBild);
  }
}


void keyPressed() {
  // SPIELER SPRINGT WENN ER KANN
  if (keyPressed)
    if (key == ' ' && wennSpielerSpringt) {
      wennSpielerSpringt();
      jumpSound.play();
    }
}

void draw() {
  zeichneFenster(false);
}

void mousePressed() {

  // ES WIRD GESCHAUT OB EIN KNOPF GEDRÜCKT WIRD
  if (spielStatus > 0) return;
  if (mouseX > 230 && mouseX < 640 && mouseY > 530 && mouseY < 900) {  // KNOPF 1
    spielStatus = 2;
    zeichneFenster(true);
  } else

    if (mouseX > 720 && mouseX < 1130 && mouseY > 530 && mouseY < 900) {   // KNOPF 2
      spielStatus = 1;
      startTheGame();
      zeichneFenster(true);
    } else

      if (mouseX > 1220 && mouseX < 1130*2 && mouseY > 530 && mouseY < 900) {  // KNOPF3
        exit();
      }
}

void zeichneFenster(boolean spielZumErstenMal) {


  if (spielStatus == 0) { ////////////////////////////////////////////////////   MENÜ ///////////////////////////////////////////////////////////////////
    if (spielZumErstenMal) {
      // MUSIK
      menu.play();
      menu.loop();
      menu.amp(0.9);
    }

    // HINTERGRUND
    imageMode(CORNER);
    image(hintergrund, 0, 0);

    // MENÜ UND BANANEN ERSTELLEN
    erstelleMenu();
    anzahlBananen = 0;   // BANANEN WERDEN ZURÜCKGESETZT
  } else if (spielStatus == 1) {  ////////////////////////////////////////////////////   SPIEL ///////////////////////////////////////////////////////////////////
    if (spielZumErstenMal) {
      startTheGame();
      menu.stop();
    }
    gameFrame();
  } else if (spielStatus == 2) {   ////////////////////////////////////////////////////  INFORMATIONEN  ///////////////////////////////////////////////////////////////////
    if (spielZumErstenMal) {
      zeitSpeicherung=frameCount;
    }
    image(info, 0, 0);
      if (zeitSpeicherung/30 + 13 < frameCount/30) {
      spielStatus = 0;
    }
  } else if (spielStatus==3) {  ////////////////////////////////////////////////////   GAME OVER ///////////////////////////////////////////////////////////////////
    if (spielZumErstenMal) {
      menu.loop();
    }
    delay(100);
    zeicheGameOver();
  }
}

// FUNKTION WO DIE STARTWERTE LÄDT
void startTheGame() {
  hintergrundX = 0;
  hintergrundY = 0;
    x = 1000;
    y= height-affe1.height;
    leben=lebenVariable;
    anzahlBananen = 0;
  wennSpielerSpringt = true;
  geschwindigkeitPflanzen = 1.5;
  listevonGegner.clear();
  speedSprungkraft = 0;
    game.play();
    game.loop();
    menu.stop();
}

// FUNKTION DIE JEDE MILISEKUNDE AUSGEFÜHRT WIRD UND DAS SPIEL AM LAUFEN LÄSST
void gameFrame() {

  int tY  = 75;

  // 3 BILDER DAMIT MAN NICHT DIE LEERE SIEHT
  imageMode(CORNER);
    image(dschungel, hintergrundX, hintergrundY);
    image(dschungel, hintergrundX+dschungel.width, hintergrundY);
    image(dschungel, hintergrundX-dschungel.width, hintergrundY);

  // BEWEGUNG HINTERGRUND
  hintergrundX-=5;
  if (hintergrundX<=0)hintergrundX+=dschungel.width; // SICHERHEIT

  // LEBENSANZEIGE
  text("Leben: " + leben, 100, 100);

  // SPRUNG
  springBerechnung();
  spielerAnimationsNummer++;
  // SPIELERANIMATION
  if (spielerAnimationsNummer == 21) spielerAnimationsNummer = 0;
  if (spielerAnimationsNummer <= 10) {
    imageMode(CENTER);
    image(affe1, x, y);
  } else {
    imageMode(CENTER);
    image(affe2, x, y);
  }

  // SPIELER HAT NACH SPRUNG DEN BODEN WIEDER BERUEHRT
  if (y >= spielerHWert - affe1.height/2) {
    spielerBoden();
  }


  // PFLANZE WIRD REGELMÄSSIG erschaffen
  if (frameCount % Math.round(abstandPflanzen) == 0 && random(0, 100) <= pflanzenProzent) {
    PImage pB = gegners.get(int(random(1, 2)));


    Gegner gegnerGegner = new Gegner(width+300, spielerHWert-pB.height/2, pB);
    listevonGegner.add(gegnerGegner);
  }

  // ALLE 330 BILDER WIRD DIE PFLANZE SCHNELLER
  if (frameCount % 330 == 0) {
    geschwindigkeitPflanzen+=0.2;
  }

  // ALLE 190 BILDER
  if (frameCount % 190 == 0) {
    Bananes.add(new Banane(width+200, spielerHWert-BananeImage.height/2));
  }

  // schleife durch die gegner (hier haben wir unterstützung bekommen) 
  for (int b = 0; b < listevonGegner.size(); b++) {
    Gegner gegnerGegner = listevonGegner.get(b);

    imageMode(CENTER);
    image(gegnerGegner.img, gegnerGegner.x, gegnerGegner.y);
    
    
    gegnerGegner.x-=0+gegnerGegner.speed; // BEWEWGUNG GENER
    boolean xRechts = x+affe1.width/2 >= gegnerGegner.x-gegnerGegner.img.width/2 && x+affe1.width/2 <= gegnerGegner.x+gegnerGegner.img.width/2;
    boolean xLinks = x-affe1.width/2 >= gegnerGegner.x-gegnerGegner.img.width/2 && x-affe1.width/2 <= gegnerGegner.x+gegnerGegner.img.width/2;
    boolean yB = y+affe1.height/2 >= gegnerGegner.y-gegnerGegner.img.height/2 && y+affe1.height/2 <= gegnerGegner.y+gegnerGegner.img.height/2;
    if (yB && (xRechts || xLinks)) { // HIER WIRD GECHECKT OB DER SPIELER DAS OBJEKT BERÜHRT QUELLE: https://www.geeksforgeeks.org/find-two-rectangles-overlap/
      gegnerGegner.spielerBerührtObjekt(); // 
      listevonGegner.remove(gegnerGegner);
    }
  }

  collisionCheck();

  textAlign(LEFT);
  textSize(30);
  fill(255);
  text("Bananen: " + anzahlBananen, 60, 60);

  textAlign(CENTER);
}

void collisionCheck() {
  for (int i = 0; i < Bananes.size(); i++) {
    Banane c = Bananes.get(i);
    c.anzeigen();

    boolean xRechts = x+affe1.width/2 >= c.x-BananeImage.width/2 && x+affe1.width/2 <= c.x+BananeImage.width/2;
    boolean xLinks = x-affe1.width/2 >= c.x-BananeImage.width/2 && x-affe1.width/2 <= c.x+BananeImage.width/2;
    boolean yB = y+affe1.height/2 >= c.y-BananeImage.height/2 && y+affe1.height/2 <= c.y+BananeImage.height/2;
    if (yB && (xRechts || xLinks)) c.collectBanana();
  }
}


// Menü erstellen Funktion
void erstelleMenu() {

  textAlign(CENTER);
  textFont(dschungelSchriftart);
  fill(255);
  textSize(200);
  text(titelName, width/2, 200);

  fill(255);
  textSize(90*2);
  text("INFO", 440, 815);
  fill(255);
  text("START", 920, 815);
  fill(255);
  text("EXIT", 1400, 815);
}

// Game Over Zeichnen Funktion
void zeicheGameOver() {
  background(0);

  textAlign(CENTER);
  textFont(dschungelSchriftart);
  fill(250);
  textSize(205);
  text("GAME OVER!", width/2, height/2);

  fill(#FEFF08);
  text("Anzahl an Bananen: " + anzahlBananen, width/2, 730);

  if (zeitSpeicherung/30f + 10 < frameCount/30f) {
    spielStatus=0;
    zeichneFenster(true);
  }
}









// Bananen Klasse (unterstützung erhalten)
class Banane {
  int x;
  int y;

  Banane(int x, int y) {
    this.x = x;
    this.y = y;
  }

  void anzeigen() {
    this.x = this.x-5;
    if (this.x < 0) Bananes.remove(this);
    image(BananeImage, x, y);
  }

  void collectBanana() {
    anzahlBananen++;
    BananeS.play();
    Bananes.remove(this);
  }
}










// Gegner Klasse (unterstützung erhalten)
class Gegner {
  int x, y;
  PImage img;
  int speed = 0;

  Gegner(int x, int y, PImage img) {
    this.x = x;
    this.y = y;
    this.img = img;

    this.speed = int(random(6, 8)*geschwindigkeitPflanzen*1.2);
  }

  void spielerBerührtObjekt() {
    if (leben-1==-1) {
      game.stop();
      spielStatus = 3;

      zeitSpeicherung=frameCount;

      zeichneFenster(true);
    }
    damageSound.play();
    leben--;
  }
}
